
c     $Id: fi_luns.F,v 1.3 2002/08/24 03:46:14 jrt Exp $


c     ====================
      subroutine fi_getlun (lun, error)
c     ====================

      use h_fi_f77_errors

      implicit none

c#     include "fi_f77_errors.h"


      integer  lun
      integer  error


      logical  open

      integer  i
cc    integer  first_lun_flag

      integer  lun_array(1:99)


cc    common  / lun_common / lun_array, first_lun_flag
      common  / lun_common / lun_array


      lun = -1


      do i = 7, 99, 1

        if (lun_array(i) /= 1) then
          inquire (unit = i, OPENED = open)
c                         =====
          if (.not. open) go to 20
c                         =====
        end if

      end do

         
      if (lun == -1) then
        error = FI_ERR_301
        call fi_message
     &    ('fi_getlun:  No logical unit numbers available$')
c       ======
        return
c       ======
      end if


c     ========
 20   continue
c     ========


      error = 0

      lun          = i
      lun_array(i) = 1


      if ((lun < 7) .or. (lun > 99)) then 
        error = FI_ERR_301
        lun   = -1
        call fi_message
     &    ('fi_getlun:  No logical unit numbers available$')
c       ======
        return
c       ======
      end if

  
      return

      end


c     ========================
      subroutine fi_releaselun (lun, error)
c     ========================
      use h_fi_f77_errors
      implicit none

c#     include "fi_f77_errors.h"


      integer  lun
      integer  error


cc    integer  first_lun_flag

      integer  lun_array(1:99)


cc    common  / lun_common / lun_array, first_lun_flag
      common  / lun_common / lun_array


      if ((lun >= 7) .and. (lun < 100)) then

         error          = 0
         lun_array(lun) = 0

      else 

        error = FI_ERR_302
        call fi_message ('fi_releaselun:  Invalid input$')

      end if


      return

      end


c     ============================
      subroutine fi_initializeluns ( )
c     ============================

      implicit none


cc    integer  first_lun_flag
      integer  i

      integer  lun_array(1:99)


cc    common  / lun_common / lun_array, first_lun_flag
      common  / lun_common / lun_array
  

      do i = 1, 99, 1
        lun_array(i) = 0
      end do


      lun_array(5) = -1
      lun_array(6) = -1


cc    first_lun_flag = -300


      return

      end

c-------------------------------------------
c Added by Roy Chen
c-------------------------------------------
      subroutine fi_message (message)

      implicit none

c     ----------------------
c     Argument declarations.
c     ----------------------

      character (len=*) :: message

c     ----------------
c     Begin execution.
c     ----------------

      Write (6,*)
      Write (6,*)
     &  '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'


      Write (6,*) '!! ' // Trim (message)
      Write (6,*)
     &  '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      Write (6,*)
      return

      end

c-----------------------------------------------------------------------
      subroutine Fi_Makedir(ier, sign, itext)
c added by Roy
c ------------------------ arguments -----------------------------------
      character(len=*), intent(in) :: itext
      character(len=*), intent(in) :: sign
      integer         , intent(out):: ier
      character(len=512)  :: text,log_dir
      integer ii,log_dir_len_str
c ----------------------------------------------------------------------

#if ( defined UNICOSMP )
      integer, external :: ishell ! System routine, execute shell command
#elif (defined IRIX64)
      integer, external :: system_cmd  ! Wrapper to "C" system command
#elif (!defined AIX)
      integer, external :: system ! System routine, execute shell command
#endif
c ----------------------------------------------------------------------
      log_dir = trim(itext)
      log_dir_len_str = 0
      DIRLOOP: do ii = 1, Len (log_dir)
        if (log_dir(ii:ii) == sign) then
c         ============
          Exit DIRLOOP
c         ============
        else
          log_dir_len_str     = log_dir_len_str + 1
        end if
      end do DIRLOOP

      text = 'mkdir -p '//log_dir(1:log_dir_len_str)

#if ( defined UNICOSMP )
      ier = ishell(trim(text))
#elif ( defined AIX )
      call system(trim(text), ier)
#elif ( defined IRIX64 )
      ier = system_cmd(trim(text))
#else
      ier = system(trim(text))
#endif

      return
      end
c--------------------------------------------------------------------------
