
      module h_phot_lookup
      implicit none
      public 
c=============================================================================
c
c $Id: phot_lookup.h,v 1.1.1.1 2001/06/07 17:44:10 jrt Exp $
c
c CODE DEVELOPER
c   Dan Bergmann, LLNL
c   dbergmann@llnl.gov
c
c FILE
c   phot_lookup.h
c
c DESCRIPTION
c   This include file contains the declarations of the photolysis reaction
c   numbers.
c
c=============================================================================


c     ----------------------------------------------------
c     All of the declarations below are "read from table."
c     ----------------------------------------------------

      integer ::
     &  num_qj_acet,      ! photolysis reaction number for ACET
     &  num_qj_ch2o,      ! photolysis reaction number for CH2O
     &  num_qj_hacn,      ! photolysis reaction number for HACN
     &  num_qj_mgly,      ! photolysis reaction number for MGLY
     &  num_qj_no,        ! photolysis reaction number for NO
     &  num_qj_o2,        ! photolysis reaction number for O2
     &  num_qj_o3_to_2oh  ! photolysis reaction number for O3 + hv = 2OH


c     ====================
c      common  / imppl_i1 /
c     ====================
c     &  num_qj_acet, num_qj_ch2o, num_qj_hacn,     num_qj_mgly,
c     &  num_qj_no,   num_qj_o2,   num_qj_o3_to_2oh
       end module h_phot_lookup

